package com.uas.ps.sync.core;

import java.io.Serializable;
import java.util.Date;

/**
 * 记录变化的消息
 *
 * @author sunyj
 * @since 2018/1/14 16:35
 */
public class SyncMessage implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 实体类
     */
    private Class clazz;

    /**
     * 更改类型
     */
    private Type type;

    /**
     * 更改的数据
     */
    private Object data;

    /**
     * 生成时间
     */
    private Date time;

    public SyncMessage() {
        this.time = new Date();
    }

    public SyncMessage(Class clazz, Type type, Object data) {
        this.clazz = clazz;
        this.type = type;
        this.data = data;
        this.time = new Date();
    }

    public Class getClazz() {
        return clazz;
    }

    public void setClazz(Class clazz) {
        this.clazz = clazz;
    }

    public Type getType() {
        return type;
    }

    public void setType(Type type) {
        this.type = type;
    }

    public Object getData() {
        return data;
    }

    public void setData(Object data) {
        this.data = data;
    }

    public Date getTime() {
        return time;
    }

    @Override
    public String toString() {
        return "SyncMessage{" +
                "clazz=" + clazz +
                ", type=" + type +
                ", data=" + data +
                ", time=" + time +
                '}';
    }

    /**
     * 变更类型
     */
    public enum Type {
        /**
         * 保存
         */
        SAVE,

        /**
         * 删除
         */
        DELETE
    }

}
