package com.uas.ps.sync.producer;

import com.uas.ps.core.util.ContextUtils;
import com.uas.ps.sync.producer.jms.JmsListener;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.context.event.ApplicationPreparedEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.web.servlet.config.annotation.EnableWebMvc;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;


/**
 * 应用入口
 *
 * @author sunyj
 * @since 2017年8月16日 下午4:00:03
 */
@SpringBootApplication
@EnableWebMvc
public class Application {
    public static void main(String[] args) throws FileNotFoundException {
        File logFile = new File("logs/log.log");
        if (!logFile.getParentFile().exists()) {
            logFile.getParentFile().mkdir();
        }
        System.setErr(new PrintStream(new FileOutputStream(logFile, true)));
        SpringApplication application = new SpringApplication(Application.class);
        application.addListeners(new ApplicationListener<ApplicationPreparedEvent>() {
            @Override
            public void onApplicationEvent(ApplicationPreparedEvent event) {
                ContextUtils.setApplicationContext(event.getApplicationContext());
            }
        });
        application.run(args);
        startTask();
    }

    /**
     * 开启定时任务
     */
    public static void startTask() {
        JmsListener jmsListener = ContextUtils.getBean(JmsListener.class);
        jmsListener.start(null);
    }
}
