package com.uas.ps.sync.producer.jms;

import com.uas.ps.sync.entity.SyncMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

/**
 * 索引创建相关请求
 *
 * @author sunyj
 * @since 2016年8月5日 上午11:42:54
 */
@Controller
@RequestMapping("/jms")
public class JmsController {

    @Autowired
    private SyncMessageDao syncMessageDao;

    @Autowired
    private SyncMessageService syncMessageService;

    @Autowired
    private JmsListener jmsListener;


    @RequestMapping("/listen/start")
    @ResponseBody
    public String startListen(Long interval, HttpServletRequest request) {
        jmsListener.start(interval);
        return "开启成功";
    }

    @RequestMapping("/listen/stop")
    @ResponseBody
    public String stopListen(HttpServletRequest request) {
        jmsListener.stop();
        return "关闭成功";
    }

    @RequestMapping("/listen/restart")
    @ResponseBody
    public String restartListen(Long interval, HttpServletRequest request) {
        if (jmsListener.isRunning()) {
            jmsListener.stop();
        }
        jmsListener.start(interval);
        return "重启成功";
    }

    @RequestMapping("/listen/details")
    @ResponseBody
    public SPage<SyncMessage> listenDetails(Integer page, Integer size, HttpServletRequest request) {
        return syncMessageService.findAll(page, size);
    }

    @RequestMapping("/dequeue")
    @ResponseBody
    public boolean dequeueLuceneQueueMessage(Long id, HttpServletRequest request) {
        syncMessageDao.dequeueMessage(id);
        return true;
    }
}
